// TDlgTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TDlgTest.h"
#include "TDlgTestDlg.h"

#include "stdredir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTDlgTestDlg dialog

CTDlgTestDlg::CTDlgTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTDlgTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTDlgTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTDlgTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTDlgTestDlg)
	DDX_Control(pDX, IDC_SHOW, m_edtShow);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTDlgTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTDlgTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTDlgTestDlg message handlers

BOOL CTDlgTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	RedirectStdout(OUT_STDOUT, REDIR_TO_CALLBACK, PrintfCallback, (DWORD)this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTDlgTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTDlgTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTDlgTestDlg::OnTest() 
{
	printf("test\n");
}

VOID CTDlgTestDlg::PrintfCallback(LPCSTR szData, INT nDataSize, DWORD dwData)
{
	CTDlgTestDlg * pDlg = (CTDlgTestDlg*)dwData;

	pDlg->m_edtShow.SetSel(pDlg->m_edtShow.GetWindowTextLength(), pDlg->m_edtShow.GetWindowTextLength());
	pDlg->m_edtShow.ReplaceSel(szData);
}
